/*

   Gspoof v. 2.1 (September 0x02) - console.c

   IMPORTANT
   From V. 2.1 Gspoof has been ported to libnet-1.1.x
   Old code (circa libnet-1.0.x) *will not work* with libnet-1.1.x and viceversa

   => To compile Gspoof >= v. 2.1 install libnet-1.1.x!
   => To compile Gspoof <= v. 2.0 install libnet-1.0.x!

*/

#include "console.h"
#include "common.h"

u_char ebuf[LIBNET_ERRBUF_SIZE];

/* random value */
u_long seq;
u_long ack;
u_short id;
u_short urgp;

/* boolean value */
u_short multi;
u_short ll;

/* flags opt */
u_short furg;
u_short fack;
u_short fpsh;
u_short frst;
u_short fsyn;
u_short ffin;

char *device; /* device (eth0, eth1, ppp0) */

u_long shost, dhost;   /* IP */
u_short sport, dport;
u_char *data; /* data (tcp payload) */

/* delay opt */
u_short delay;
u_short durate;

/* temp variable 4 eth addr */
u_char *seth_temp;
u_char *deth_temp;

/* eth addr */
u_char *seth;
u_char *deth;

/* eth type */
u_char *ethtype;
u_short evalue;

/* other opt */
u_short tos;
u_short ttl;
u_short win;
u_short datalen; /* data (tcp payload) lenght */

/* libnet file context (new from libnet-1.1.x ) */
libnet_t *l;

/* other */
u_char keystroke;
u_short i;
u_char *cmd;
u_char *value;

void run_console()
{
   u_char r;
   u_short t;

   t = furg = fack = fpsh = frst = ffin = multi = ll = datalen = 0;
   fsyn = 1;
   tos = 8;
   ttl = 64;
   win = 32767;
   device = NULL;

   cmd = malloc (10 * sizeof(u_char));
   value = malloc (20 * sizeof(u_char));
   seth = malloc (6 * sizeof(u_char));
   deth = malloc (6 * sizeof(u_char));
   ethtype = malloc (4 * sizeof(u_char));
   data = malloc (512 * sizeof(u_char));

   for (i=0; i<6; i++) deth[i]=0;
   sprintf (ethtype, "ip");
   evalue = 0x0800;  /* ip value = default */

   randomize();
   autoscan();

   for (;;)
     {
	print_menu();

	printf ("\n");

	if (!t)
	  {
	     printf ("COMMAND (type 'help' for avaible commands) > ");
	     t = 1 ;
	  }
	else
	  printf ("COMMAND > ");
	
	fgets(cmd, 10, stdin);
	cmd = dn(cmd);
	printf ("\n");
	
	sleep (1);

	/* read commands */
        if (!strcmp ("1.1", cmd))
	  {
	     printf ("INTERFACE (%s) : ", device);
	     scanf ("%s", device);
             keystroke =getchar();
	  }
	else if (!strcmp ("1.2", cmd))
	  {
	     printf ("SOURCE HW ADDRESS (%X:%X:%X:%X:%X:%X) : ", seth[0], seth[1], seth[2], seth[3], seth[4], seth[5]);
	     do
	       {
		  fgets(value, 20, stdin);
		  free(seth);
		  seth = emb_hex_aton(value);
		  if (seth==NULL)
		    printf ("WRONG MAC ADDRESS! - Retype it : ");
	       }
	     while (seth==NULL);
	  }
	else if (!strcmp ("1.3", cmd))
	  {
	     printf ("DESTINATION HW ADDRESS (%X:%X:%X:%X:%X:%X) : ", deth[0], deth[1], deth[2], deth[3], deth[4], deth[5]);
	     do
	       {
		  fgets(value, 20, stdin);
		  free (deth);
		  deth = emb_hex_aton(value);
		  if (deth==NULL)
		    printf ("WRONG MAC ADDRESS! - Retype it : ");
	       }
	     while (deth==NULL);
	  }
	else if (!strcmp ("1.4", cmd))
	  {
	     do
	       {
		  printf ("ETHERNET TYPE (%s) (ip/lo) : ", ethtype);
		  fgets(ethtype, 20, stdin);
		  ethtype = dn(ethtype);
	       }
	     while (strcmp("ip", ethtype) && strcmp("lo", ethtype));
             if (strcmp(ethtype, "ip")) evalue = 0x9000; /*strcmp return 0 if strings are equal! */
	  }
	else if (!strcmp ("2.1", cmd))
	  {
	     do
	       {
		  printf ("SOURCE ADDRESS (%s) : ", libnet_addr2name4(shost, LIBNET_DONT_RESOLVE));
		  fgets(value, 20, stdin);
		  if ((shost = libnet_name2addr4(l, dn(value), LIBNET_RESOLVE))==-1)
		    printf ("Error reading source IP\n");
	       }
	     while (shost == -1);

	  }
	else if (!strcmp ("2.2", cmd))
	  {
	     do
	       {
		  printf ("DESTINATION ADDRESS (%s) : ", libnet_addr2name4(dhost, LIBNET_DONT_RESOLVE));
		  fgets(value, 20, stdin);
		  if ((dhost = libnet_name2addr4(l, dn(value), LIBNET_RESOLVE))==-1)
		    printf ("Error reading destination IP\n");
	       }
	     while (dhost == -1);
	  }
	else if (!strcmp ("2.3", cmd))
	  {
	     do
	       {
		  printf ("TIME TO LIVE (%d) : ", ttl);
		  fgets(value, 20, stdin);
		  ttl = atoi (value);
	       }
	     while (ttl > 255 || atoi(value) < 0);
	  }
	else if (!strcmp ("2.4", cmd))
	  {
	     do
	       {
		  printf ("ID NUMBER (%d) : ", id);
		  fgets(value, 20, stdin);
		  id = atoi (value);
	       }
	     while (atol(value) > 65535 || atoi(value) < 0);
	  }
	else if (!strcmp ("2.5", cmd))
	  {
	     do
	       {
		  printf ("TYPE OF SERVICE (%d) : ", tos);
		  fgets(value, 20, stdin);
		  tos = atoi (value);
	       }
	     while (tos > 255 || atoi(value) < 0);
	  }
	else if (!strcmp ("3.1", cmd))
	  {
	     do
	       {
		  printf ("SOURCE PORT (%d) : ", sport);
		  fgets(value, 20, stdin);
		  sport = atoi(value);
	       }
	     while (atol(value) > 65535 || atoi(value) < 0);
	  }
	else if (!strcmp ("3.2", cmd))
	  {
	     do
	       {
		  printf ("DESTINATION PORT (%d) : ", dport);
		  fgets(value, 20, stdin);
		  dport = atoi(value);
	       }
	     while (atol(value) > 65535 || atoi(value) < 0);
	  }
	else if (!strcmp ("3.3", cmd))
	  {
	     for (;;)
	       {
		  printf ("\nFLAGS ARE NOW SET : URG %d - RST %d - ACK %d - SYN %d -  PSH %d - FIN %d\n\n",  furg, frst,  fack, fsyn, fpsh, ffin);
		  printf ("WHAT FLAG DO YOU WANT TO CHANGE? (URG/RST/ACK/SYN/PSH/FIN) (TYPE 'DONE' TO END) : ");
		  fgets(value, 20, stdin);

		  value = dn(value);

		  if (!strcmp("URG", value) || !strcmp("urg", value))
		    {
		       do
			 {
			    printf ("URG FLAG (%d) : ", furg);
			    fgets(value, 3, stdin);
			    furg = atoi(value);
			    value = dn(value);
			 }
		       while (strcmp(value, "0") && strcmp(value, "1"));
		    }
		  else if (!strcmp("RST", value) || !strcmp("rst", value))
		    {
		       do
			 {
			    printf ("RST FLAG (%d) : ", frst);
			    fgets(value, 3, stdin);
			    frst = atoi(value);
			    value = dn(value);
			 }
		       while (strcmp(value, "0") && strcmp(value, "1"));
		    }
		  else if (!strcmp("ACK", value) || !strcmp("ack", value))
		    {
		       do
			 {
			    printf ("ACK FLAG (%d) : ", fack);
			    fgets(value, 3, stdin);
			    fack = atoi(value);
			    value = dn(value);
			 }
		       while (strcmp(value, "0") && strcmp(value, "1"));
		    }
		  else if (!strcmp("SYN", value) || !strcmp("syn", value))
		    {
		       do
			 {
			    printf ("SYN FLAG (%d) : ", fsyn);
			    fgets(value, 3, stdin);
			    fsyn = atoi(value);
			    value = dn(value);
			 }
		       while (strcmp(value, "0") && strcmp(value, "1"));
		    }
		  else if (!strcmp("PSH", value) || !strcmp("psh", value))
		    {
		       do
			 {
			    printf ("PSH FLAG (%d) : ", fpsh);
			    fgets(value, 3, stdin);
			    fpsh = atoi(value);
			    value = dn(value);
			 }
		       while (strcmp(value, "0") && strcmp(value, "1"));
		    }
		  else if (!strcmp("FIN", value) || !strcmp("fin", value))
		    {
		       do
			 {
			    printf ("FIN FLAG (%d) : ", ffin);
			    fgets(value, 3, stdin);
			    ffin = atoi(value);
			    value = dn(value);
			 }
		       while (strcmp(value, "0") && strcmp(value, "1"));
		    }
		  else if (!strcmp("DONE", value) || !strcmp("done", value))
		    break;
	       }
	  }
	else if (!strcmp ("3.4", cmd))
	  {
	     do
	       {
		  printf ("SEQUENCE NUMBER (%ld) : ", seq);
		  fgets(value, 20, stdin);
		  seq = atol(value);
	       }
	     while (atoi(value) < 0 || atoll(value) > 4294970000);
	  }
	else if (!strcmp ("3.5", cmd))
	  {
	     do
	       {
		  printf ("ACKNOWLEDGEMENT NUMBER (%ld) : ", ack);
		  fgets(value, 20, stdin);
		  ack = atol(value);
	       }
	     while (atoi(value) < 0 || atoll(value) > 4294970000);
	  }
	else if (!strcmp ("3.6", cmd))
	  {
	     do
	       {
		  printf ("WINDOW SIZE (%d) : ", win);
		  fgets(value, 20, stdin);
		  win = atoi(value);
	       }
	     while (atoi(value) < 0 || atol (value) > 65535);
	  }
	else if (!strcmp ("3.7", cmd))
	  {
	     do
	       {
		  printf ("URG POINTER (%d) : ", urgp);
		  fgets(value, 20, stdin);
		  urgp = atoi(value);
	       }
	     while (atoi(value) < 0 || atol (value) > 65535);
	  }
	else if (!strcmp ("4.1", cmd))
	  {
	     printf ("INSERT DATA : ");
	     fgets(data, 512, stdin);
             data = dn (data);
	     datalen = strlen (data);
	  }
	else if (!strcmp ("4.2", cmd))
	  {
	     do
	       {
		  printf ("LINK LAYER OPERATIONS (1=ENABLE / 0=DISABLE) : ");
		  fgets(value, 3, stdin);
		  ll = atoi(value);
	       }
	     while (ll!=0 && ll!=1);
	  }
	else if (!strcmp ("4.3", cmd))
	  {
	     do
	       {
		  printf ("\"PSEUDO_FLOAD\" (1=ENABLE / 0=DISABLE) : ");
		  fgets(value, 3, stdin);
		  multi = atoi(value);
	       }
	     while(multi!=0 && multi!=1);

	     if (multi)
	       {
		  printf ("BREAK (ms) : ");
		  fgets(value, 20, stdin);
		  delay=atoi(value);
		  printf ("DURATE (s) : ");
		  fgets(value, 20, stdin);
		  durate=atoi(value);
	       }
	  }
       	/* */
	else if (!strcmp ("send", cmd))
	  {
	     r = 'n';
	     do
	       {
		  printf ("%sAre you sure? (y/n) >%s ", RED, WHITE);
		  r=getchar();
	       }
	     while (r!='y' && r!='Y' && r!='n' && r!='N');

	     if (r == 'y' || r == 'Y')
	       sendpkg();
	  }
	else if(!strcmp ("quit", cmd))
	  {
	     printf ("%sGoodbye!%s\n\n", RED, WHITE);
      	     /* free memory */
	     free (cmd);
	     free (value);
	     free (seth);
	     free (deth);
	     free (data);
	     free (ethtype);
	     return;
	  }
	else if(!strcmp ("reset", cmd))
	  {
	     randomize();
	     autoscan();
	  }
	else if(!strcmp ("help", cmd))
	  {
	     printf ("Numbers (1.2, 3.2, 2.2...) : modify corresponding fields\n");
	     printf ("'send' : write packet on the net!\n");
	     printf ("'reset': reset default values\n");
	     printf ("'quit' : exit from program\n");
	     printf ("'help' : print this kiddie help\n\n");
	     printf ("Read README for more info (press a Key)");
	     keystroke = getchar();
	  }
	else
	  printf ("%sError : %s : unknow command!%s Type 'help' for avaible commands\n", RED, cmd, WHITE);
     }

}

void print_menu()
{
   printf ("%s\n+------------------------------------------------+\n\n", GREEN);
   printf ("%s\tETHERNET FIELDS\n%s", RED, WHITE);
   printf ("%s1.1%s INTERFACE \t\t\t: %s\n", GREEN, WHITE, device);
   printf ("%s1.2%s SOURCE ADDRESS \t\t: %X:%X:%X:%X:%X:%X\n", GREEN, WHITE, seth[0], seth[1], seth[2], seth[3], seth[4], seth[5]);
   printf ("%s1.3%s DESTINATION ADDRESS \t: %X:%X:%X:%X:%X:%X\n",GREEN, WHITE,  deth[0], deth[1], deth[2], deth[3], deth[4], deth[5]);
   printf ("%s1.4%s ETHERNET TYPE \t\t: %s\n", GREEN, WHITE, ethtype);

   printf ("\n");

   printf ("%s\tIP FIELDS\n%s", RED, WHITE);
   printf ("%s2.1%s SOURCE ADDRESS \t\t: %s\n", GREEN, WHITE, libnet_addr2name4(shost, LIBNET_DONT_RESOLVE));
   printf ("%s2.2%s DESTINATION ADDRESS \t: %s\n", GREEN, WHITE, libnet_addr2name4(dhost, LIBNET_DONT_RESOLVE));
   printf ("%s2.3%s TIME TO LIVE \t\t: %d\n", GREEN, WHITE, ttl);
   printf ("%s2.4%s ID NUMBER \t\t\t: %d\n", GREEN, WHITE, id);
   printf ("%s2.5%s TYPE OF SERVICE \t\t: %d\n", GREEN, WHITE, tos);

   printf ("\n");

   printf ("%s\tTCP FIELDS\n%s", RED, WHITE);
   printf ("%s3.1%s SOURCE PORT \t\t: %d\n", GREEN, WHITE, sport);
   printf ("%s3.2%s DESTINATION PORT \t\t: %d\n", GREEN, WHITE, dport);
   printf ("%s3.3%s FLAGS \t\t\t: URG %d - RST %d\n", GREEN, WHITE, furg, frst);
   printf ("\t\t\t\t: ACK %d - SYN %d\n", fack, fsyn);
   printf ("\t\t\t\t: PSH %d - FIN %d\n", fpsh, ffin);
   printf ("%s3.4%s SEQUENCE NUMBER \t\t: %ld\n", GREEN, WHITE, seq);
   printf ("%s3.5%s ACKNOWLEDGEMENT NUMBER \t: %ld\n", GREEN, WHITE, ack);
   printf ("%s3.6%s WINDOW SIZE \t\t: %d\n", GREEN, WHITE, win);
   printf ("%s3.7%s URG POINTER \t\t: %d\n", GREEN, WHITE, urgp);

   printf ("\n");

   printf ("%s\tOPTIONS\n%s", RED, WHITE);
   if (datalen)
     printf ("%s4.1%s PAYLOAD \t\t\t: %s (%d byte)\n", GREEN, WHITE, data, datalen);
   else
     printf ("%s4.1%s PAYLOAD \t\t\t: (VOID) (0 byte)\n", GREEN, WHITE);
   if (ll)
     printf ("%s4.2%s LINK LAYER OPERATIONS \t: ENABLED\n", GREEN, WHITE);
   else
     printf ("%s4.2%s LINK LAYER OPERATIONS \t: DISABLED\n",GREEN, WHITE);
   if (multi)
     printf ("%s4.3%s \"PSEUDO_FLOAD\" \t\t: ENABLED:  BREAK = %dms ;  LENGHT = %ds\n", GREEN, WHITE, delay, durate);
   else
     printf ("%s4.3%s \"PSEUDO_FLOAD\" \t\t: DISABLED, SENDING 1 PACKET AT TIME\n", GREEN, WHITE);

   printf ("\n");

}

void randomize()
{
   libnet_seed_prand(l);
   id = (u_short) libnet_get_prand(LIBNET_PRu16);
   seq = libnet_get_prand(LIBNET_PRu32);
   ack = libnet_get_prand(LIBNET_PRu32);
   urgp = (u_short) libnet_get_prand(LIBNET_PRu16);
}

void autoscan()
{
   struct libnet_ether_addr *ethaddr; /* tmp eth address */

   if ((l=libnet_init (LIBNET_LINK, NULL, ebuf))==NULL)
     {
  	fprintf (stderr, "\nError creating libnet file context : %s", ebuf);
	fprintf (stderr, "Have you activated a non-loopback device like eth0? (man ifconfig)\n\n");
        exit_fail();
     }

   if ((device=libnet_getdevice(l))==NULL)
     {
	fprintf (stderr, "\nError: cannot get device name : %s\n", libnet_geterror(l));
	exit_fail();
     }

   shost = libnet_get_ipaddr4(l);
   if (shost == -1)
     {
        fprintf (stderr, "\nError: autodetect device ip address failed: %s\n", libnet_geterror(l));
	exit_fail();
     }

   ethaddr = libnet_get_hwaddr(l);
   if (ethaddr == NULL)
     {
        fprintf (stderr, "\nError: autodetect device MAC address failed: %s\n", libnet_geterror(l));
	exit_fail();
     }

   for (i=0; i<6; i++)
     seth[i] = ethaddr->ether_addr_octet[i];

   /* close network descriptor */
   libnet_destroy(l);

}

void sendpkg()
{
   u_short len; /* packet lenght */
   short w; /* byte written */
   u_short flag;
   u_short dcount;
   u_short c;

   dcount = c = 0;

   /* control flags */
   flag = 0x00;
   if (ffin) flag+=0x01;
   if (fsyn) flag+=0x02;
   if (frst) flag+=0x04;
   if (fpsh) flag+=0x08;
   if (fack) flag+=0x10;
   if (furg) flag+=0x20;

   /* total packet lenght */
   len = LIBNET_ETH_H + LIBNET_IPV4_H + LIBNET_TCP_H + datalen;
   /* ll=0 -> len = len - LIBNET_ETH_H (LIBNET_ETH_H is build by kernel and not libnet! */

   if (ll)
     l = libnet_init (LIBNET_LINK, device, ebuf);
   else
     l = libnet_init (LIBNET_RAW4, NULL, ebuf);

   if (l==NULL)
     {
	fprintf (stderr, "Error creating libnet file context : %s\n", ebuf);
	exit_fail();
     }

   printf ("%s* Libnet file context created\n", GREEN);

   switch (ll)
     {
      case 0:
	/* TCP */
	if (libnet_build_tcp(sport, dport, seq, ack, flag, win, 0, urgp, LIBNET_TCP_H + datalen, data, datalen, l, 0)==-1)
	  {
	     fprintf (stderr,"Error during TCP header creation : %s\n", libnet_geterror(l));
	     exit_fail();
	  }
	printf ("* TCP header build\n");

        /* IP */
	if (libnet_build_ipv4(LIBNET_TCP_H + LIBNET_IPV4_H + datalen, tos, id, 0, ttl, IPPROTO_TCP, 0, shost, dhost, NULL, 0, l, 0)==-1)
	  {
	     fprintf (stderr, "Error during IP header creation : %s\n", libnet_geterror(l));
	     exit_fail();
	  }
	printf ("* IP header build\n");

	if (multi)
	  {
	     printf ("\n** Writing %d ms spaced packets for %d seconds: ", delay, durate);
	     fflush(stdout);
	     while (dcount < durate*1000)
	       {
		  c++;
		  w = libnet_write(l);
		  if (w==-1)
		    {
		       fprintf (stderr, "Error: %s", libnet_geterror(l));
		       exit_fail();
		    }

		  printf (". ");
		  fflush(stdout);
		  usleep(delay*1000); /*ms! */
		  dcount+=delay;
	       }
	     printf ("%sDonE! (%d * %d byte)%s\n", RED, c, len, WHITE);
	  }
	else
	  {
	     w = libnet_write(l);
	     if (w==-1)
	       {
		  fprintf (stderr, "Error: %s", libnet_geterror(l));
		  exit_fail();
	       }

	     printf("\n%s** Packet has been correctly send (total %d bytes) %s\n", RED, len, WHITE);
	  }

	/* at the end we close raw_socket */
	libnet_destroy(l);

	keystroke = getchar();
	printf ("%s", WHITE);
	break;

      case 1: 	/* link layer operations */

	printf("* Interface %s correctly opened\n", device);

	/* TCP creation */
	if (libnet_build_tcp(sport, dport, seq, ack, flag, win, 0, urgp, LIBNET_TCP_H + datalen, data, datalen, l, 0)==-1)
	  {
	     fprintf (stderr, "Error during TCP header creation : %s\n", libnet_geterror(l));
	     exit_fail();
	  }
	printf ("* TCP header build\n");

	/* IP creation */
	if (libnet_build_ipv4(LIBNET_IPV4_H + LIBNET_TCP_H + datalen, tos, id, 0, ttl, IPPROTO_TCP, 0, shost, dhost, NULL, 0, l, 0)==-1)
	  {
	     fprintf (stderr, "Error during IP header creation : %s\n", libnet_geterror(l));
	     exit_fail();
	  }
	printf ("* IP header build\n");

	/* ETH creation */
	if (libnet_build_ethernet(deth, seth, evalue, NULL, 0, l, 0)==-1)
	  {
	     fprintf (stderr, "Error during ethernet header creation : %s\n", libnet_geterror(l));
	     exit_fail();
	  }
	printf ("* Ethernet frame build\n");

	if (multi)
	  {
	     printf ("\n** Writing %d ms spaced packets for %d seconds: ", delay, durate);
	     fflush(stdout);
	     while (dcount < durate*1000)
	       {
		  c++;
		  w = libnet_write(l);
		  if (w==-1)
		    {
		       fprintf (stderr, "Error: %s", libnet_geterror(l));
		       exit_fail();
		    }

		  printf (". ");
		  fflush(stdout);
		  usleep(delay*1000); /*ms! */
		  dcount+=delay;
	       }
	     printf ("%sDonE! (%d * %d byte)%s\n", RED, c, len, WHITE);
	  }
	else
	  {
	     w = libnet_write(l);
	     if (w==-1)
	       {
		  fprintf (stderr, "Error: %s", libnet_geterror(l));
		  exit_fail();
	       }

	     printf("\n%s** Packet has been correctly send (total %d bytes) %s\n", RED, len, WHITE);
	  }

	/* close all */
	libnet_destroy(l);

	keystroke = getchar();
	printf ("%s", WHITE);

	break;
     }
}

int exit_fail()
{
   libnet_destroy(l);
   if (cmd)   free (cmd);
   if (value) free (value);
   if (seth) free (seth);
   if (deth) free (deth);
   if (data) free (data);
   if (ethtype) free (ethtype);
   exit(-1);
}
