/*
   Gspoof v. 2.1 - main.c
 
   GTK + Console mainfile

   IMPORTANT
   From V. 2.1 Gspoof has been ported to libnet-1.1.x
   Old code (circa libnet-1.0.x) *will not work* with libnet-1.1.x and viceversa

   => To compile Gspoof >= v. 2.1 install libnet-1.1.x!
   => To compile Gspoof <= v. 2.0 install libnet-1.0.x!
 
 */

#include <gtk/gtk.h>

#include "interface.h"
#include "callbacks.h"
#include "console.h"
#include "common.h"
#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <getopt.h>

int
  main (int argc, char *argv[])
{
   GtkWidget *mainwin;
   char opt;
   int console;
   
   if (getuid()||getgid())
     {
	printf ("You must be r00t!\n");
        return 0;	
     }

   printf ("\n\033[9;36m %s \033[0;0m\n", BANNER);

   console = 0;

   while ((opt=getopt(argc, argv, ":cCh?"))!=-1)
     {
	switch(opt)
	  {
	   case 'c':
	   case 'C':
	     console = 1;
	     break;
	   case 'h':
	   case '?':
      	     puts ("\nUse -c flag to pass to interactive-console mode (gspoof -c)");
	     puts ("Default is GTK mode, which is avaible only if you have compile it during installation\n\n");
	     return 0;
	  }
     }

   if (console)
     {
	puts ("\n\t-----------------------");
	puts ("\tRunning in Console Mode");
	puts ("\t-----------------------");
		
	/* use run_console() main function of console.c */
        run_console();
     }

   else
     {
	puts ("\n\t------------------------");
	puts ("\tRunning in Graphics Mode");
	puts ("\t------------------------\n");

	gtk_set_locale (); 
	gtk_init (&argc, &argv);

	mainwin = create_mainwin ();
	gtk_widget_show (mainwin);

	/* construct default value */
	to_DEFAULT();

	gtk_main ();
     }

   return 0;
}
